<?
define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

$uploaddir = realpath(dirname(__FILE__)) . DIRECTORY_SEPARATOR . 'mwpdata' . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR;

// Table names
define('MWP_PAGES_TABLE', $table_prefix.'mwp_pages');
define('MWP_IMAGES_TABLE', $table_prefix.'mwp_images');

//Limitations
$max_count = 3;
$max_width = 200;
$max_height = 150;

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

// Check the permissions
if ( !$userdata['session_logged_in'] )
{
	message_die(GENERAL_ERROR, $lang['Not_Authorised']);
}

// Create webpage
if ( isset( $_POST['create'] ) )
{
	$sql = "INSERT INTO ". MWP_PAGES_TABLE ."
				VALUES (NULL, '$userdata[user_id]', '$_POST[page_alias]', '$_POST[page_title]', '$_POST[page_description]', '$_POST[page_email]')";
	$template->assign_block_vars('switch_message_box',array());
	if ( !($result = $db->sql_query($sql)) )
	{
		$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_not_created']));
	}
	else
	{
		$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_created']));
	}
}

// Update webpage
if ( isset( $_POST['update'] ) )
{
	$sql = "UPDATE ". MWP_PAGES_TABLE ."
				SET page_title = '$_POST[page_title]', page_description = '$_POST[page_description]', page_email = '$_POST[page_email]'
				WHERE page_user_id = '$userdata[user_id]' AND page_alias = '$_POST[page_alias]'";
	$template->assign_block_vars('switch_message_box',array());
	if ( !($result = $db->sql_query($sql)) )
	{
		$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_not_updated']));
	}
	else
	{
		$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_updated']));
	}
}

// Get the details from the webpages table
$sql = "SELECT *
		FROM ". MWP_PAGES_TABLE ."
		WHERE page_user_id = '$userdata[user_id]'";

$result = $db->sql_query($sql);
$webpage_row = $db->sql_fetchrow($result);

if ( !$webpage_row )
{
	$webpage = array(
		'page_alias' => '',
		'page_title' => $_POST['page_title'],
		'page_description' => $_POST['page_description'],
		'page_email' => $_POST['page_email']
	);
	$template->assign_block_vars('switch_aliaschange_allowed',array());
	$template->assign_block_vars('switch_create_mode',array());
	$template->assign_vars(array(
		'L_MWP_SUBTITLE' => $lang['mwp_create_new']));
}
else
{
	$webpage = $webpage_row;
	$template->assign_block_vars('switch_aliaschange_disallowed',array());
	$template->assign_block_vars('switch_update_mode',array());
	$template->assign_vars(array(
		'L_MWP_SUBTITLE' => $lang['mwp_view_update'],
		'L_MWP_NO_IMAGES' => $lang['mwp_no_images']));

	// Upload picture
	if ( isset( $_POST['upload_image'] ) )
	{
		// Get the images count from the images table
		$sql = "SELECT COUNT(image_id) as images_count
				FROM ". MWP_IMAGES_TABLE ."
				WHERE image_user_id = '$userdata[user_id]'";

		$result = $db->sql_query($sql);
		$images_row = $db->sql_fetchrow($result);
		if ( $images_row['images_count'] < $max_count )
		{
			$can_upload = true;
		}
		else
		{
			$can_upload = false;
		}
		$file_parts = explode('.', $_FILES['userfile']['name']);
		$file_ext = $file_parts[count($file_parts) - 1];
		$file_name = $userdata['user_id'] . '_' . time() . '.' . $file_ext;
		$uploadfile = $uploaddir . $file_name;

		//Checking for file type
		$allowed_types = array('gif','png','jpg','jpeg');
		if ( !in_array( $file_ext, $allowed_types ) )
		{
			$can_upload = false;
		}

		//Checking for sizes
		if ( $can_upload )
		{
			if ( ($file_ext == 'jpg') or ($file_ext == 'jpeg') ) { $imagesrc = imagecreatefromjpeg($_FILES['userfile']['tmp_name']); }
			if ( $file_ext == 'gif' ) { $imagesrc = imagecreatefromgif($_FILES['userfile']['tmp_name']); }
			if ( $file_ext == 'png' ) { $imagesrc = imagecreatefrompng($_FILES['userfile']['tmp_name']); }
			if ( $imagesrc )
			{
				if ( (imagesx($imagesrc) > $max_width) or (imagesy($imagesrc) > $max_height) )
				{
					$can_upload = false;
				}
				imagedestroy($imagesrc);
			}
			else
			{
				$can_upload = false;
			}
		}

		$template->assign_block_vars('switch_imagesmessage_box',array());

		if ( $can_upload )
		{
			if (move_uploaded_file($_FILES['userfile']['tmp_name'], $uploadfile)) {
				$sql = "INSERT INTO ". MWP_IMAGES_TABLE ."
							VALUES ('', $userdata[user_id], '$file_name')";
				if ( !($result = $db->sql_query($sql)) )
				{
					$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_not_uploaded']));
				}
				else
				{
					$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_uploaded']));
				}

			} else {
			   $template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_not_uploaded']));
			}
		}
		else
		{
		   $template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_not_uploaded']));
		}
	}

	// Delete picture
	if ( isset( $_POST['delete_image'] ) )
	{
		$sql = "SELECT *
				FROM ". MWP_IMAGES_TABLE ."
				WHERE image_user_id = '$userdata[user_id]' AND image_id = '$_POST[image_id]'";

		$result = $db->sql_query($sql);
		if ( $images_row = $db->sql_fetchrow($result) )
		{
			unlink($uploaddir.$images_row['image_name']);

			$sql = "DELETE FROM ". MWP_IMAGES_TABLE ."
						WHERE image_user_id = '$userdata[user_id]' AND image_id = '$_POST[image_id]'
						LIMIT 1";
			$template->assign_block_vars('switch_imagesmessage_box',array());
			if ( !($result = $db->sql_query($sql)) )
			{
				$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_not_deleted']));
			}
			else
			{
				$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_deleted']));
			}
		}
		else
		{
			$template->assign_vars(array('MWP_MESSAGE' => $lang['mwp_not_deleted']));
		}
	}

	// Get the images count from the images table
	$sql = "SELECT COUNT(image_id) as images_count
			FROM ". MWP_IMAGES_TABLE ."
			WHERE image_user_id = '$userdata[user_id]'";

	$result = $db->sql_query($sql);
	$images_count = $db->sql_fetchrow($result);
	if ( $images_count['images_count'] < $max_count )
	{
		$template->assign_block_vars('switch_uploadpicture_allowed',array());
	}
	if ( $images_count['images_count'] == 0 )
	{
		$template->assign_block_vars('no_images',array());
	}
	else
	{
		$template->assign_block_vars('switch_deletebutton_allowed',array());
	}

	// Get the images from the images table
	$sql = "SELECT *
			FROM ". MWP_IMAGES_TABLE ."
			WHERE image_user_id = '$userdata[user_id]'";

	$result = $db->sql_query($sql);
	if ( $images_row = $db->sql_fetchrow($result) )
	{
		do
		{
			$template->assign_block_vars('imagesrow', array(
				'IMAGE_ID' => $images_row['image_id'],
				'IMAGE_URL' => 'http://'.$board_config['server_name'].$board_config['script_path'].'mwpdata/images/'.$images_row['image_name']
			));
		}
		while ( $images_row = $db->sql_fetchrow($result) );
		$db->sql_freeresult($result);
	}

}

$template->assign_vars(array(
	'MWP_PAGE_ALIAS' => $webpage['page_alias'],
	'MWP_PAGE_TITLE' => $webpage['page_title'],
	'MWP_PAGE_DESCRIPTION' => $webpage['page_description'],
	'MWP_PAGE_EMAIL' => $webpage['page_email'],

	'L_MWP_ALIAS' => $lang['mwp_alias'],
	'L_MWP_ALIAS_EXPLAIN' => $lang['mwp_alias_explain'],
	'L_MWP_URL' => $lang['mwp_url'],
	'L_MWP_URL_EXPLAIN' => $lang['mwp_url_explain'],
	'L_MWP_TITLE' => $lang['mwp_title'],
	'L_MWP_DESCRIPTION' => $lang['mwp_description'],
	'L_MWP_DESCRIPTION_EXPLAIN' => $lang['mwp_description_explain'],
	'L_MWP_EMAIL' => $lang['mwp_email'],
	'L_MWP_UPLOADED_PICTURES' => $lang['mwp_uploaded_pictures'],
	'L_MWP_CREATE' => $lang['mwp_create'],
	'L_MWP_DELETE' => $lang['mwp_delete'],
	'L_MWP_UPDATE' => $lang['mwp_update'],
	'L_MWP_UPLOAD' => $lang['mwp_upload'],
	'L_MWP_RESET' => $lang['mwp_reset'],
	'L_MWP_LIMITATIONS' => $lang['mwp_limitations'],

	'MWP_WEBPAGE_URL' => 'http://'.$board_config['server_name'].$board_config['script_path'].'webpage/'
));


$template->set_filenames(array('mwp_editor' => 'mwp_editor.tpl'));

$page_title = $lang['mwp_my_webpage'];

include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->pparse('mwp_editor');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
?>